addpath(genpath('/home/tm150/MATLAB/freezeColors'));
addpath(genpath('/home/tm150/MATLAB/subplot_tight'));

load('w.txt'); wlat = w;
%load ('resps_test.txt'); resps = resps_test;

NBCELLS_S1 = size(w, 1);

% w = zscore(wlat_S1);
wt = w'; w = w(~eye(size(w))); wt = wt(~eye(size(wt)));
disp('Correlation between the lateral weight matrix and its transpose (i.e. symmmetry of lateral connections):');
corrsym=corr(w, wt); disp(corrsym);
%figure; plot(w, wt, '*'); xlabel('Weight A->B'); ylabel('Weight B->A'); title('Lateral connection symmetry'); 
%set(gcf, 'Position', [100 100 300 300]);
%print(gcf, '-dpng', '-r0', ['connectionsymmetry_' FILENAME '.png'])   

if 1 == 0
    % Is there a correlation between connection pattern similarity and mutual connection weight?
    corrs=[];
    clat = corr(wlat_S1);
    for nc1=1:NBCELLS_S1
        for nc2=nc1+1:NBCELLS_S1
            corrs = [corrs; wlat_S1(nc1, nc2) + wlat_S1(nc2, nc1)  clat(nc1, nc2) ];
        end
    end
    disp('Correlation between connection pattern similarity and mutual connection weight:');
    corrwinwmut =  (corr(corrs(:,1), corrs(:,2)));
    disp(corrwinwmut);
    %figure; plot(corrs(:,1), corrs(:,2), '*'); ylabel('Correlation between A and B''s weight vectors'); xlabel('Weight of A <-> B connection');  title('Mutual connection weight vs. overall connection similarity'); 
    %set(gcf, 'Position', [100 100 300 300]);
    %print(gcf, '-dpng', '-r0', ['mutualvsother_' FILENAME '.png'])   




    % Is there a correlation between firing similarity and mutual connection weights?
    corrfirings = corr(rasterS); %, 'type', 'spearman');
    corrfirings = corrfirings(~eye(size(corrfirings)));
    disp('Correlation between firing similarity and mutual connection weight:');
    disp(corr(w, corrfirings)); %, 'type', 'spearman'));
end


%return;

% Are there clusters of firing patterns?



if 1 == 0    
    load ('resps_test.txt'); 

    myresps = resps_test(:, end-999:end);  % last 1000.

    sr = myresps';
    %sr=sr(1:10:1000,:);

    nums = 1:NBCELLS_S1;

    corrsrRP = corr(sr'); % Notice the transpose - columns are image presentations
    corrsrRP(isnan(corrsrRP(:))) = 0;
    lnk = linkage(double(corrsrRP), 'single', 'correlation');


    % You just need to have the endrogram window pop up - there's apparently no way to recover the leaf-order from linkage  without that (optimalleaforder does something else...)
    figure; [h t oRP] = dendrogram(lnk,size(corrsrRP,1));
    clustmat = corrsrRP(oRP',oRP');
    title(pwd);

    % Same thing for the BAthellier data:
    load('../../../bathellier/CC_And_Vector_Values.mat');
    pm =  mean(P, 3); % averaging over all presentations of the same stimulus... 
    corrsrRP_b = corr(pm); 
    corrsrRP_b(isnan(corrsrRP_b(:))) = 0;
    lnk_b = linkage(double(corrsrRP_b), 'single', 'correlation');
    figure; [h t oRP_b] = dendrogram(lnk_b,size(corrsrRP_b,1));
    clustmat_b = corrsrRP_b(oRP_b',oRP_b');


    figclust = figure; 

    %subplot_tight(2,2, 1, [.1 .03]);
    subplot_tight(2,2, 1, .1);
    imagesc(sr'); colormap(hot);
    set(gca,'xtick',[]);  set(gca,'xticklabel',[])
    set(gca,'ytick',[]);  set(gca,'yticklabel',[])

    subplot_tight(2,2, 2, .1);
    imagesc(sr(oRP,:)');
    set(gca,'xtick',[]);  set(gca,'xticklabel',[])
    set(gca,'ytick',[]);  set(gca,'yticklabel',[])

    subplot_tight(2,2, 3, .1);
    imagesc(clustmat);
    set(gca,'xtick',[]);  set(gca,'xticklabel',[])
    set(gca,'ytick',[]);  set(gca,'yticklabel',[])

    subplot_tight(2,2, 4, .1);
    imagesc(clustmat_b);
    set(gca,'xtick',[]);  set(gca,'xticklabel',[])
    set(gca,'ytick',[]);  set(gca,'yticklabel',[])

    axes('Position', [0.01 0.01 0.99 0.99], 'Visible', 'off');
    cb1 = colorbar; set(cb1,  'xticklabel', [], 'yticklabel', []);
    caxis([0 max(sr(:))]);
    set(cb1, 'Position', [0.95 .1 .025 .35]);
    cb2 = colorbar; set(cb2,  'xticklabel', [], 'yticklabel', []);
    caxis([0 1]);
    set(cb2, 'Position', [0.95 .55 .025 .35]);

    set(figclust, 'Units', 'Centimeters', 'Resize', 'Off', 'Position', [10 10 11 10], 'PaperPosition', [0 0 11 10]);
    %print(gcf, '-dtiff', '-r300', ['test.tiff'])   
    %saveas(figclust, 'figurecluster.png');
end

if 1 == 1

  % SPONTANEOUS NO-INH DIVERGE 
   figspontdiv =  figure;
    
   ll=load('lastnresps_spont.txt');  s=sum(ll);z=zeros(1000, 50); z(:)=s(:); s1=ll(5,:); z1=z; z1(:) = s1(:);        
    hold off;
    z1 = z1(1:500,:);  % only use the first 500 ms
    plot(smooth(sum(z1,2)./50,  10), 'r', 'Linewidth', 2) 
    
    ll=load('lastnresps_spont_noinh.txt'); s=sum(ll);z=zeros(1000, 50); z(:)=s(:); s1=ll(5,:); z1=z; z1(:) = s1(:);        
    hold on;
    z1 = z1(1:500,:);  % only use the first 500 ms
    plot(smooth(sum(z1,2)./50,  10), 'g', 'Linewidth', 2) 
    
    ll=load('lastnresps_spont_nolat_noinh.txt'); s=sum(ll);z=zeros(1000, 50); z(:)=s(:); s1=ll(5,:); z1=z; z1(:) = s1(:);        
    hold on;
    z1 = z1(1:500,:);  % only use the first 500 ms
    plot(smooth(sum(z1,2)./50,  10), 'b', 'Linewidth', 2) 
    
    axis([0  500 0 .15]);
    %set(gca,'xtick',[] ,'xticklabel',[], 'ytick', [], 'yticklabel', []);
    set(gca, 'xticklabel',[], 'yticklabel', [] ); % we keep the ticks!

    set(figspontdiv, 'Units', 'Centimeters', 'Resize', 'Off', 'Position', [10 10 5 3], 'PaperPosition', [0 0 5 3]);
    %saveas(figspontdiv, 'figspontdiv.png');
end

if 1 == 0    

    % SPONTANEOUS

    BINSIZE=10;

    ll = load('lastnresps_spont.txt');
    
    lc=zeros(size(ll));
    for nn=1:BINSIZE
        lc = lc + circshift(ll, [0 nn-1]);
    end;
    lc(lc > 1) = 1;  % Some bins may contains more than one spike. 
    thresh=1;
    while (mean(sum(lc) > thresh) > .1)
        thresh = thresh + 1;
    end
    sr = lc(:, sum(lc)>thresh)';

    %sr = sr(1:1000,:);

    nums = 1:NBCELLS_S1;

    corrsrRP = corr(sr'); % Notice the transpose - columns are image presentations
    corrsrRP(isnan(corrsrRP(:))) = 0;
    lnk = linkage(double(corrsrRP), 'single', 'correlation');


    % You just need to have the dendrogram window pop up - there's apparently no way to recover the leaf-order from linkage  without that (optimalleaforder does something else...)
    figure; [h t oRP] = dendrogram(lnk,size(corrsrRP,1));
    clustmat = corrsrRP(oRP',oRP');
    title(pwd);

    figspont = figure; 

    %    subplot_tight(4,4, (1:4:16)');
    subplot_tight(1,3, 1, .0751);
    imagesc(max(sr(:)) - sr'); colormap(gray);
    set(gca,'xtick',[]);  set(gca,'xticklabel',[])
    set(gca,'ytick',[]);  set(gca,'yticklabel',[])

    subplot_tight(1,3, 2, .0751);
    imagesc(max(sr(:)) - sr(oRP,:)');
    set(gca,'xtick',[]);  set(gca,'xticklabel',[])
    set(gca,'ytick',[]);  set(gca,'yticklabel',[])

    subplot_tight(1,3, 3, .0751);
    imagesc(clustmat); colormap(hot);
    set(gca,'xtick',[]);  set(gca,'xticklabel',[])
    set(gca,'ytick',[]);  set(gca,'yticklabel',[])


    set(figspont, 'Units', 'Centimeters', 'Resize', 'Off', 'Position', [10 10 15 4], 'PaperPosition', [0 0 15 4]);
    %print(gcf, '-dtiff', '-r300', ['test.tiff'])   
    %saveas(figspont, 'figurespont.png');
end


if (1 == 0)

    %PULSE
    %For pulse (for test1, with ./stdp pulse 999259 ; for others, replace /5/ with the appropriate cell number - one that has high firing for this pattern):
    figpulse = figure;

    ll=load('lastnresps_pulse_nolat.txt'); s=sum(ll);z=zeros(350, 50); z(:)=s(:); s1=ll(5,:); z1=z; z1(:) = s1(:);        
    hold off;
    plot(smooth(sum(z1,2)./50,  10), 'b', 'Linewidth', 2) 
    ll=load('lastnresps_pulse.txt'); s=sum(ll);z=zeros(350, 50); z(:)=s(:); s1=ll(5,:); z1=z; z1(:) = s1(:);        
    hold on;
    plot(smooth(sum(z1,2)./50,  10), 'r', 'Linewidth', 2) 
    axis([0  120 0 .22]);
    %set(gca,'xtick',[] ,'xticklabel',[], 'ytick', [], 'yticklabel', []);
    set(gca, 'xticklabel',[], 'yticklabel', []); % we keep the ticks!

    set(figpulse, 'Units', 'Centimeters', 'Resize', 'Off', 'Position', [10 10 5 3], 'PaperPosition', [0 0 5 3]);
    %saveas(figpulse, 'figurepulse.png');

end

% MIXING

% Run the two following commands first:
% ./stdp mix 999259      999179 
% ./stdp mix 999259      999179  nolat

if (1 == 0)

    load resps_mix.txt; r= resps_mix; %cc = corr(r); v = cc(:, [60 61]); 

    NBMIXES = size(resps_mix, 2)/3;
    figmix=figure; colormap(hot);subplot(1,4,1); imagesc(r(:,1:NBMIXES)); set(gca,'xtick',[],'ytick',[]); subplot(1,4,2); imagesc(r(:, (NBMIXES + 1):2*NBMIXES));  set(gca,'xtick',[],'ytick',[]); subplot(1,4,3); imagesc(r(:, (2*NBMIXES + 1):end)); set(gca,'xtick',[],'ytick',[]); 
    subplot(1,4,4);
    %set(0,'DefaultAxesFontSize',14); subplot(141); imagesc(r(:,1:30)); title('Mixed stimuli,  0% / 100% to 100% / 0%'); subplot(142); imagesc(r(:,31:60)); title('Stimulus 1 alone, 0% to 100%'); subplot(143); 
    %imagesc(r(:,61:end)); title('Stimulus 2 alone, 100% to 0%'); subplot(144); plot(1:30,v(1:30,1), 'r', 1:30, v(1:30,2), 'b', 'Linewidth', 2); axis([1 30 -.3 1.05]);

    load resps_mix.txt; rl= resps_mix; load resps_mix_nolat.txt; rnl= resps_mix_nolat;
    bs=[]; bs_nl=[];
    for nn=1:NBMIXES
        [b bint] = regress(rl(:, nn)./norm(rl(:,nn)), [rl(:,1)./norm(rl(:,1)), rl(:, NBMIXES)./norm(rl(:,NBMIXES))]);
        [bnl bint] = regress(rnl(:, nn)./norm(rnl(:,nn)), [rnl(:,1)./norm(rnl(:,1)), rnl(:, NBMIXES)./norm(rnl(:,NBMIXES))]);
        bs = [bs b]; bs_nl = [bs_nl bnl];
    end
    set(groot,'defaultAxesColorOrder',[1 0 0;0 0 1]);
    hold off; plot([1:NBMIXES], bs', 'LineWidth', 2); axis([1 NBMIXES -.05 1.05]); hold on; plot([1:NBMIXES], bs_nl', ':', 'LineWidth', 2); axis([1 NBMIXES -.05 1.05]); set(gca,'xtick',[],'ytick',[]);

    set(figmix, 'Position' , [200 200 1000 500], 'Resize', 'off');
    set(figmix, 'PaperUnits', 'Centimeters');
    set(figmix, 'PaperPosition', [0 0 16 8]);

    %print(gcf, '-r300', '-dpng', 'figuremix.png');
    %saveas(figmix, 'figuremix.png');


end


return;

% Previous version:
load resps_mix.txt; r= resps_mix; cc = corr(r); v = cc(:, [60 61]);
load resps_mix_nolat.txt; rnolat= resps_mix_nolat; ccnl = corr(rnolat); vnl = ccnl(:, [60 61]);
figmix = figure;
%set(0,'DefaultAxesFontSize',14); subplot_tight(141); imagesc(r(:,1:30)); title('Mixed stimuli,  0% / 100% to 100% / 0%'); subplot_tight(142); imagesc(r(:,31:60)); title('Stimulus 1 alone, 0% to 100%'); subplot_tight(143); imagesc(r(:,61:end)); title('Stimulus 2 alone,  100% to 0%'); subplot_tight(144); plot(1:30,v(1:30,1), 'r', 1:30, v(1:30,2), 'b', 'Linewidth', 2); axis([1 30 -.3 1.05]);
subplot_tight(141); imagesc(r(:,1:30)); set(gca,'xtick',[]);  set(gca,'xticklabel',[]); set(gca,'ytick',[]);  set(gca,'yticklabel',[]);
subplot_tight(142); imagesc(r(:,61:end)); set(gca,'xtick',[]);  set(gca,'xticklabel',[]); set(gca,'ytick',[]);  set(gca,'yticklabel',[]);
subplot_tight(143); imagesc(r(:,31:60)); set(gca,'xtick',[]);  set(gca,'xticklabel',[]); set(gca,'ytick',[]);  set(gca,'yticklabel',[]);
subplot_tight(144); plot(1:30,v(1:30,1), 'r', 1:30, v(1:30,2), 'b', 'Linewidth', 2); axis([1 30 -.2 1.05]); set(gca,'xtick',[]);  set(gca,'xticklabel',[]); set(gca,'ytick',[]);  set(gca,'yticklabel',[]);

figmix.Units = 'inches';
figmix.Position = [1 1 7 3];

%figmixnolat = figure;
%set(0,'DefaultAxesFontSize',14); subplot_tight(141); imagesc(rnolat(:,1:30)); title('Mixed stimuli,  0% / 100% to 100% / 0%'); subplot_tight(142); imagesc(rnolat(:,31:60)); title('Stimulus 1 alone, 0% to 100%'); subplot_tight(143); imagesc(rnolat(:,61:end)); title('Stimulus 2 alone,  100% to 0%'); subplot_tight(144); plot(1:30,vnl(1:30,1), 'm', 1:30, vnl(1:30,2), 'c', 'Linewidth', 2); axis([1 30 -.3 1.05]);







