RFSIZE = 17;
CROPMARGIN = 6;
CROPSIZE = RFSIZE + 2*CROPMARGIN;
NBFRAMES = 110000;
MAXRATE = 70; % in Hz

DoG = fspecial('gaussian', 9, .5) - fspecial('gaussian', 9, 1.0);
patches = zeros(RFSIZE*RFSIZE* NBFRAMES, 1);

load('./IMAGES.mat');

% =====>>>> Zscoring or dividing by sum(abs) create patches with strong "dots"!!!!

rng(0);

RF_SD = 6;
z=fspecial('gaussian', RFSIZE, RF_SD); z=z./max(z(:)); GAUSSIANMASK = z;

sump = zeros(RFSIZE);

patchesim={};
pos = 1;
for numframe=1:NBFRAMES
    if mod(numframe, 1000) == 1
        disp(numframe);
    end
    numim = randi(10); x = randi(512 -1 - CROPSIZE); y = randi(512 -1 - CROPSIZE);
    mypatch_large = IMAGES(x:x+CROPSIZE-1, y:y+CROPSIZE-1, numim);
    
    %mypatch_large = imrotate(mypatch_large, -18, 'bilinear',  'crop');  % PRE-rotation
    
    zangle = floor(rand() * 360);
    mypatch_large = imrotate(mypatch_large, zangle, 'bilinear',  'crop');
    
    
    %mypatch_large = imrotate(mypatch_large, -18, 'bilinear',  'crop');  % POST-rotation
    
    
    mypatch = mypatch_large(CROPMARGIN + 1:end-CROPMARGIN, CROPMARGIN + 1:end-CROPMARGIN); 

    % The following may not be useful given the rotation (except maybe for the transpose?) but why not..
    if (rand() > .5)
        mypatch = mypatch';
    end
    if (rand() > .5)
        mypatch = flipud(mypatch);
    end
    if (rand() > .5)
        mypatch = fliplr(mypatch); % was a repeat of flipud!
    end
    %mypatch(:) = zscore(mypatch(:));


    %mypatch = imfilter(mypatch, DoG);


    mypatch(:) = mypatch(:)-mean(mypatch(:));
    
    
    %mypatch = mypatch .* GAUSSIANMASK;
    
    
    mypatch(:) = MAXRATE * mypatch(:)./(1e-12 + sum(abs(mypatch(:))));
    %mypatch(:) = MAXRATE * mypatch(:)./(1e-12 + max(abs(mypatch(:))));
    
    sump = sump + abs(mypatch);
    
    patches(pos:pos + RFSIZE * RFSIZE -1, 1) = mypatch(:);
    patchesim{numframe}  =  mypatch;
    pos = pos + RFSIZE * RFSIZE;
end

%patches = patches-mean(patches); patches = MAXRATE * patches./max(abs(patches));

%save(['test.mat'], 'patches');
%save(['patchesCenteredScaledByMaxRotatedONOFF.mat'], 'patches');
%save(['patchesCenteredScaledBySumTo' num2str(MAXRATE) 'EachFrameRotatedONOFF.mat'], 'patches');
save(['patchesCenteredScaledBySumTo' num2str(MAXRATE) 'EachFrameRotated.mat'], 'patches');
%save(['patchesCenteredScaledBySumTo' num2str(MAXRATE) 'EachFrameRotatedMinus18PRE.mat'], 'patches');
%save(['patchesCenteredScaledBySumTo' num2str(MAXRATE) 'EachFrameRotatedMinus18.mat'], 'patches');
%save(['patchesCenteredScaledByMaxRotatedWithMinus18PreRotation.mat'], 'patches');
%save(['patchesCenteredScaledByMaxRotated.mat'], 'patches');
%save(['patchesCenteredNotScaledRotated.mat'], 'patches');
%save(['patchesCenteredNotScaledRotated_Gauss' num2str(RF_SD) '.mat'], 'patches');

% DOESN'T WORK - seems to generate 1-byte pixels...
%fid=fopen(['patchesCenteredScaledBySumTo' num2str(MAXRATE) 'EachFrameRotated_Gauss' num2str(RF_SD) '.dat'], 'w');
%fwrite(fid, patches);
%fclose(fid);

if (1 == 0)
START = RFSIZE * RFSIZE * 20;
pp = reshape(patches(1+START:START+ RFSIZE*RFSIZE*30), RFSIZE, RFSIZE*30);
imagesc(pp); colormap(gray); axis equal;
end
